/*
 * EmulOS 2
 * PowerPC 750 CPU
 */
#include <emulos.h>
#include "common.h"

// === CONSTANTS ===
#define	MAX_VCPUS	1

// === GLOBALS ===
tCPU	gaCPUs[MAX_VCPUS];
tSPRDef	gaSPRDefs[1024];

// === CODE ===
/**
 * \fn int DriverInit(int NCPUs, void **CPUs)
 * \brief Initialise CPUs
 */
int DriverInit(int NCPUs, void **CPUs)
{
	 int	i;
	if(NCPUs > MAX_VCPUS)	NCPUs = MAX_VCPUS;
	
	gaSPRDefs[1].Name = "XER";	gaSPRDefs[1].UserAccessable = TRUE;
	
	for( i = 0; i < NCPUs; i++ )
	{
		CPUs[i] = &gaCPUs[i];
		//TODO: Initialise Processor State
	}
	
	return NCPUs;
}
