; EmulOS 2 x86 BIOS ROM
;
;
; EBDA: ??? - 0xA0000

ORG 0xF0000
[section .text]
[BITS 16]
BiosEntry:
	; CS = 0xF000
	
	; Go to protected mode
	lgdt [gGDTPtr-0xF0000]
	mov eax, cr0
	or	al, 1
	mov	cr0, eax
	jmp 08h:ProtectedMode

[BITS 32]
ProtectedMode:
	; Set up segments
	mov ax, 10h
	mov ds, ax
	mov ss, ax
	mov es, ax
	mov fs, ax
	mov gs, ax

	mov esp, 0xA0000
	
	hlt

ErrHandler0:
	push	0
	jmp	CommonErrHandler
CommonErrHandler:
	add esp, 8
	iret

IRQHandler:
	iret

gIDT:
	dd	0,0
gIDTPtr:
	dw	$-gIDT-1
	dd	gIDT

gGDT:
	dd	0, 0
	dd	0x0000FFFF, 0x00CF9800	; Code 32
	dd	0x0000FFFF, 0x00CF9200	; Data 32
gGDTPtr:
	dw	$-gGDT-1
	dd	gGDT

times (0x10000-0x10-($-$$))	nop
[BITS 16]
	jmp	BiosEntry-0xF0000
times (0x10000-($-$$))	nop
