# EmulOS 2
# Common Driver Makefile
# Makefile.tpl

CC = gcc
AS = nasm
LD = ld

ASFLAGS += -f elf
CPPFLAGS += -nostdinc -I ../../include
CFLAGS += -Wall -Werror -fno-stack-protector
LDFLAGS += -T ../../link.ld -L../.. -lemulos

all: $(BIN)

$(BIN): $(OBJ)
	$(LD) $(LDFLAGS) -o $@ $(OBJ)

%.o: %.c
	$(CC) -o $@ -c $< $(CFLAGS) $(CPPFLAGS)
%.ao: %.asm
	$(AS) -o $@ $< $(ASFLAGS)
%.rom: %.asm
	$(AS) -o $@ $< -f bin
	ld -r -b binary -o $@.tmp $@
	mv $@.tmp $@
