OUTPUT_FORMAT(elf32-i386)

ENTRY(DriverInit)

SECTIONS
{
	. = BASE + SIZEOF_HEADERS;

	.interp : { *(.interp) }
	.hash  : { *(.hash) }
	.dynsym : { *(.dynsym) }
	.dynstr : { *(.dynstr) }
	.rel.dyn :
	{
		*(.rel.init)
		*(.rel.text .rel.text.* .rel.gnu.linkonce.t.*)
		*(.rel.fini)
		*(.rel.rodata .rel.rodata.* .rel.gnu.linkonce.r.*)
		*(.rel.data.rel.ro* .rel.gnu.linkonce.d.rel.ro.*)
		*(.rel.data .rel.data.* .rel.gnu.linkonce.d.*)
		*(.rel.tdata .rel.tdata.* .rel.gnu.linkonce.td.*)
		*(.rel.tbss .rel.tbss.* .rel.gnu.linkonce.tb.*)
		*(.rel.ctors)
		*(.rel.dtors)
		*(.rel.got)
		*(.rel.bss .rel.bss.* .rel.gnu.linkonce.b.*)
	}
	.rela.dyn :
	{
		*(.rela.init)
		*(.rela.text .rela.text.* .rela.gnu.linkonce.t.*)
		*(.rela.fini)
		*(.rela.rodata .rela.rodata.* .rela.gnu.linkonce.r.*)
		*(.rela.data .rela.data.* .rela.gnu.linkonce.d.*)
		*(.rela.tdata .rela.tdata.* .rela.gnu.linkonce.td.*)
		*(.rela.tbss .rela.tbss.* .rela.gnu.linkonce.tb.*)
		*(.rela.ctors)
		*(.rela.dtors)
		*(.rela.got)
		*(.rela.bss .rela.bss.* .rela.gnu.linkonce.b.*)
	}
	.rel.plt	: { *(.rel.plt) }
	.rela.plt	: { *(.rela.plt) }
	.dynamic    : { *(.dynamic) }
	.got        : { *(.got) }
	
	.text ALIGN(0x1000) : AT(ADDR(.text))
	{
		*(.text)
	}
	
	.rodata : AT(ADDR(.rodata))
	{
		*(.rodata)
	}

	. = (. + 0xFFF) & ~ 0xFFF;
	.got.plt : { *(.got.plt) }
	.data    :
	{
		*(.data)
	}
	
	. = (. + 0xFFF) & ~ 0xFFF;
	.bss : AT(ADDR(.bss))
	{
		*(.bss)
	}
}
