; EmulOS 2
; By thePowersgang
; bin_elf.inc.asm
; - ELF Binary Loader

struc tELF_Header
	.Ident:	resb	16-12
	.dynhash:	resd	1
	.dynsym:	resd	1
	.DYNAMIC:	resd	1
	.FileType:	resw	1
	.Machine:	resw	1
	.Version:	resd	1
	.Entrypoint:	resd	1
	.PHdrOff:	resd	1
	.SHdrOff:	resd	1
	.Flags:	resd	1
	.HdrSize:	resw	1
	.phentsize:	resw	1
	.phentcount:	resw	1
	.shentsize:	resw	1
	.shentcount:	resw	1
	.shstrindex:	resw	1
endstruc

struc tELF_PhEnt
	.Type:	resd	1
	.Offset:	resd	1
	.VAddr:	resd	1
	.PAddr:	resd	1
	.FileSize:	resd	1
	.MemSize:	resd	1
	.Flags:	resd	1
	.Align:	resd	1
endstruc

struc tELF_Rel
	.Offset:	resd	1
	.Info:	resd	1
endstruc

struc tELF_Rela
	.Offset:	resd	1
	.Info:	resd	1
	.Addend:	resd	1
endstruc

struc tELF_Dyn
	.Type:	resd	1
	.Value:	resd	1
endstruc

struc tELF_Sym
	.Name:	resd	1
	.Value:	resd	1
	.Size:	resd	1
	.Info:	resb	1
	.Other:	resb	1
	.Shndx:	resw	1
endstruc
; sizeof = 16

%define DT_NULL		0		;	Marks End of list
;%define DT_NEEDED	1	;	Offset in strtab to needed library
;%define DT_PLTRELSZ	2	;Size in bytes of PLT
;%define DT_PLTGOT	3	Address of PLT/GOT
%define	DT_HASH		4	;	Address of symbol hash table
%define	DT_STRTAB	5	;	String Table address
%define	DT_SYMTAB	6	;	Symbol Table address
%define	DT_RELA		7	;	Relocation table address
%define	DT_RELASZ	8	;	Size of relocation table
%define	DT_RELAENT	9	;	Size of entry in relocation table
;%define	DT_STRSZ	10	;	Size of string table
;%define	DT_SYMENT	11	;	Size of symbol table entry
;%define	DT_INIT	12	;	Address of initialisation function
;%define	DT_FINI	13	;	Address of termination function
;%define	DT_SONAME	14	;	String table offset of so name
;%define	DT_RPATH	15	;	String table offset of library path
;%define	DT_SYMBOLIC	16	;	Reverse order of symbol searching for library, search libs first then executable
%define	DT_REL		17	;	Relocation Entries (Elf32_Rel instead of Elf32_Rela)
%define	DT_RELSZ	18	;	Size of above table (bytes)
%define	DT_RELENT	19	;	Size of entry in above table
;%define	DT_PLTREL	20	;	Relocation entry of PLT
;%define	DT_DEBUG	21	;	Debugging Entry - Unknown contents
;%define	DT_TEXTREL	22	;	Indicates that modifcations to a non-writeable segment may occur
%define	DT_JMPREL	23	;	Address of PLT only relocation entries
