; EmulOS 2
; By thePowersGang

KERNEL_BASE	equ	0xF0000000
MM_FRACTAL	equ	0xFF800000	; Last Page is left unmapped to catch dereferencing of -1

%define PROC_THREAD_ZERO	0
%define PROC_THREAD_MACHINE	1
%define PROC_THREAD_VIDEO	2
%define PROC_THREAD_AUDIO	3
%define PROC_THREAD_INPUT	4
%define PROC_THREAD_VCPU0	5

%define	MAGIC_BREAK	xchg bx, bx

%define	CPU0_USES_PIT	1

%macro PUSHM 1-*
%rep %0
	push %1
%rotate 1
%endrep
%endmacro
%macro POPM 1-*
%rep %0
%rotate -1
	pop %1
%endrep
%endmacro

%macro FRAME_OPEN_PUSH	1-*
	%define NSAVED	%0
%rep %0
	push %1
%rotate 1
%endrep
%endmacro
%macro FRAME_OPEN	3
	%define	SAVED_REGS	%3
	%define NVARS	%1
	%define NPARAM	%2
	push ebp
	mov ebp, esp
	FRAME_OPEN_PUSH %3
	sub esp, (NPARAM+NVARS)*4
%endmacro
%macro FRAME_CLOSE	0
	add esp, (NPARAM+NVARS)*4
	POPM SAVED_REGS
	pop ebp
	%undef NVARS
	%undef NPARAM
	%undef NSAVED
	%undef SAVED_REGS
%endmacro

%define ARG1	[ebp+8]
%define ARG2	[ebp+12]
%define ARG3	[ebp+16]
%define ARG4	[ebp+20]
%define ARG5	[ebp+24]

%define VAR1	[ebp-NSAVED*4-4]
%define VAR2	[ebp-NSAVED*4-8]
%define VAR3	[ebp-NSAVED*4-12]
%define VAR4	[ebp-NSAVED*4-16]
%define VAR5	[ebp-NSAVED*4-20]
%define VAR6	[ebp-NSAVED*4-24]
%define VAR7	[ebp-NSAVED*4-28]
%define VAR8	[ebp-NSAVED*4-32]
%define VAR9	[ebp-NSAVED*4-36]
%define VAR10	[ebp-NSAVED*4-40]

%ifndef _DEBUG_ASM
[extern E9_Str]
[extern E9_Char]
[extern E9_Hex8]
[extern E9_Fmt]
%endif

%macro DEBUG	1+
	mov DWORD [ %%saved + 0 ], eax
	mov DWORD [ %%saved + 4 ], ecx
	mov DWORD [ %%saved + 8 ], edx
[section .rodata]
%%str:
	db	%1,0
[section .bss]
%%saved:
	resd	3
[section .text]
	push %%str
	call E9_Fmt
	add esp, 4	; Remove from stack
	mov eax, DWORD [ %%saved + 0 ]
	mov ecx, DWORD [ %%saved + 4 ]
	mov edx, DWORD [ %%saved + 8 ]
%endmacro

%macro DUMP_STACK	2-*
	push eax
	sub esp, 4
[section .rodata]
%%titlestr:
	db	%1
[section .text]
	mov DWORD [esp], %%titlestr
	call E9_Str
	mov DWORD [esp], 10
	call E9_Char
	
	%rotate 1
	%assign i	0
	%rep %0-1
[section .rodata]
%%str%0:
	db	%1
[section .text]
	mov DWORD [esp], %%str%0
	call E9_Str
	mov DWORD [esp], '='
	call E9_Char
	mov eax, [esp+(2+i)*4]
	mov [esp], eax
	call E9_Hex8
	mov DWORD [esp], 10
	call E9_Char
	%assign	i	i+1
	%rotate 1
	%endrep
	mov DWORD [esp], 10
	call E9_Char
	add esp, 4
	pop eax
%endmacro
