; EmulOS 2
; By thePowersGang
; emu/exports.asm
; - Emulator Interface Exports
[BITS 32]
%include "common.inc.asm"

[extern Memory_Register]
[extern Memory_Read]
[extern Memory_Write]
[extern Memory_LockBus]
[extern Memory_UnlockBus]
[extern Emu_DumpRegs]
[extern strcmp]

[section .text]
[global Emu_GetSymbol]
Emu_GetSymbol:
	FRAME_OPEN	0,0,{esi,edi}
	
	mov esi, ARG1	; Name
	xor edi, edi
	
.search.top:
	cmp edi, gExports_size
	jae	.retZero
	mov DWORD [esp], esi
	mov eax, DWORD [gExports+edi*8]
	mov DWORD [esp+4], eax
	;DEBUG	"strcmp('%s','%s')",10
	call strcmp
	test eax, eax
	jnz .search.next
	mov ecx, DWORD ARG2
	mov eax, DWORD [gExports+edi*8+4]
	mov DWORD [ecx], eax
	mov eax, 1
	jmp .ret
.search.next:
	inc edi
	jmp .search.top
.search.end:

.retZero:
	xor eax, eax
.ret:
	FRAME_CLOSE
	ret

[extern MM_Allocate]
[global MM_AllocateBlock]
MM_AllocateBlock:
	FRAME_OPEN	0, 1, {edi}
	mov edi, ARG2
	mov eax, ARG1
	mov [esp], ebx
.loop:
	call MM_Allocate
	test eax, eax
	jz .ret
	add DWORD [esp], 0x1000
	sub edi, 0x1000
	jae .ret
	jmp .loop
.ret:
	FRAME_CLOSE
	ret

;; memcpy
;; \param Dest
;; \param Source
;; \param Count
memcpy:
	push edi
	push esi
	mov edi, [esp+12]
	mov esi, [esp+16]
	mov ecx, [esp+20]
	rep movsb
	mov eax, [esp+12]
	pop esi
	pop edi
	ret

[section .rodata]
gExports:
	dd	cExportsStrings_MemRegister, Memory_Register
	dd	cExportsStrings_MemRead, Memory_Read
	dd	cExportsStrings_MemWrite, Memory_Write
	dd	cExportsStrings_MemLockBus, Memory_LockBus
	dd	cExportsStrings_MemUnlockBus, Memory_UnlockBus
	dd	cExportsStrings_Debug, E9_Fmt	;TODO: Create a more complete debug function
	dd	cExportsStrings_EmuDumpRegs, Emu_DumpRegs
	dd	cExportsStrings_MMAllocBlock, MM_AllocateBlock
	dd	cExportsStrings_memcpy, memcpy
gExports_size	equ	($-gExports)/8
cExportsStrings_MemRegister:
	db	"Memory_Register",0
cExportsStrings_MemRead:
	db	"Memory_Read",0
cExportsStrings_MemWrite:
	db	"Memory_Write",0
cExportsStrings_MemLockBus:
	db	"Memory_LockBus",0
cExportsStrings_MemUnlockBus:
	db	"Memory_UnlockBus",0
cExportsStrings_Debug:
	db	"Debug",0
cExportsStrings_EmuDumpRegs:
	db	"Emu_DumpRegs",0
cExportsStrings_MMAllocBlock:
	db	"MM_AllocateBlock",0
cExportsStrings_memcpy:
	db	"memcpy",0
