OUTPUT_FORMAT(elf32-i386)

kbase = 0xF0000000;

ENTRY(start)

SECTIONS
{
	. = 0x100000;
	
	.mboot : AT(ADDR(.mboot))
	{
		*(.mboot)
	}
	
	. += kbase;
	
	code = .;
	.text : AT(ADDR(.text) - kbase)
	{
		*(.text)
	}
	
	.rodata : AT(ADDR(.rodata) - kbase)
	{
		*(.rodata)
	}

	.data : AT(ADDR(.data) - kbase)
	{
		*(.data)
	}
	
	. = (. + 0xFFF) & ~ 0xFFF;
	
	.padata : AT(ADDR(.padata) - kbase)
	{
		*(.padata)
	}
	
	. = (. + 0xFFF) & ~ 0xFFF;
	bss = .;
	.bss : AT(ADDR(.bss) - kbase)
	{
		*(.bss)
	}
	end = .;
}
