; EmulOS 2
; By thePowersGang
%include "common.inc.asm"

[BITS 32]
[section .mboot]
[extern code]
[extern bss]
[extern end]
mboot:
	MBOOT_PAGE_ALIGN	equ 1<<0	; Align Kernel to page boundries
	MBOOT_MEMORY_INFO	equ 1<<1	; Provide Memory Information
	MBOOT_MAGIC	equ 0x1BADB002
	MBOOT_FLAGS	equ MBOOT_PAGE_ALIGN|MBOOT_MEMORY_INFO
	MBOOT_CHECKSUM	equ -(MBOOT_MAGIC+MBOOT_FLAGS)
	
	dd	MBOOT_MAGIC
	dd	MBOOT_FLAGS
	dd	MBOOT_CHECKSUM
	dd	mboot	; Multiboot Header Location
	dd	code	; Start of .text
	dd	bss	; Start of .bss
	dd	end	; End of kernel image

[section .text]
[extern main]
[global start]
start:
	; Save Multiboot Info
	mov [_giMultibootMagic-KERNEL_BASE], eax
	add ebx, KERNEL_BASE
	mov [_giMultibootPtr-KERNEL_BASE], ebx
	
	; Set up paging
	mov eax, _gMainPageDir - KERNEL_BASE
	mov cr3, eax
	mov eax, cr0
	or eax, 0x80000000
	mov cr0, eax
	
	; Load GDT
	lgdt [_gGDTP]
	mov ax, 0x10
	mov ss, ax
	mov ds, ax
	mov es, ax
	mov gs, ax
	mov fs, ax
	
	; Set new stack
	mov esp, gKernelStack
	
	; Go to core kernel (and move to upper memory)
	jmp 0x08:main
	

[section .data]
_gGDT:
	dd 0x00000000, 0x00000000	; NULL Entry
	dd 0x0000FFFF, 0x00CF9800	; Code 32
	dd 0x0000FFFF, 0x00CF9200	; Data 32
_gGDTP:
	dw $-_gGDT-1	; Size/Limit
	dd _gGDT		; GDT Base
[global _giMultibootPtr]
_giMultibootMagic:	dd	0
_giMultibootPtr:	dd	0

[section .padata]
[global _gKernelPageTable]
[global _gMainPageDir]
_gKernelPageTable:
	%assign i	0
	%rep	1024
	dd	i*0x1000+3
	%assign i	i+1
	%endrep
_gMainPageDir:
	dd	_gKernelPageTable - KERNEL_BASE + 3
	times	(KERNEL_BASE>>22)-1	dd	0
	dd	_gKernelPageTable - KERNEL_BASE + 3
	times	1024-(KERNEL_BASE>>22)-1	dd	0
	
[section .bss]
	resb	4096*8
gKernelStack:
